package org.nakedobjects.nos.store.hibernate;

import java.io.Serializable;
import java.sql.Connection;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.hibernate.CacheMode;
import org.hibernate.Criteria;
import org.hibernate.EntityMode;
import org.hibernate.Filter;
import org.hibernate.FlushMode;
import org.hibernate.HibernateException;
import org.hibernate.Interceptor;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.ReplicationMode;
import org.hibernate.SQLQuery;
import org.hibernate.ScrollMode;
import org.hibernate.ScrollableResults;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.collection.PersistentCollection;
import org.hibernate.engine.EntityKey;
import org.hibernate.engine.PersistenceContext;
import org.hibernate.engine.QueryParameters;
import org.hibernate.engine.SessionFactoryImplementor;
import org.hibernate.engine.SessionImplementor;
import org.hibernate.engine.query.HQLQueryPlan;
import org.hibernate.engine.query.sql.NativeSQLQuerySpecification;
import org.hibernate.event.EventListeners;
import org.hibernate.impl.CriteriaImpl;
import org.hibernate.jdbc.Batcher;
import org.hibernate.jdbc.JDBCContext;
import org.hibernate.loader.custom.CustomQuery;
import org.hibernate.persister.entity.EntityPersister;
import org.hibernate.stat.SessionStatistics;
import org.hibernate.type.Type;
import org.nakedobjects.nof.core.util.NotImplementedException;


public class SessionPlaceHolder implements Session, SessionImplementor {

    private static final long serialVersionUID = 1L;

    private void notImplemented() {
        throw new NotImplementedException("Not Implemented");
    }

    public void afterScrollOperation() {
        notImplemented();
    }

    public void afterTransactionCompletion(boolean arg0, Transaction arg1) {
        notImplemented();
    }

    public void beforeTransactionCompletion(Transaction arg0) {
        notImplemented();
    }

    public String bestGuessEntityName(Object arg0) {
        notImplemented();
        return null;
    }

    public Connection connection() {
        notImplemented();
        return null;
    }

    public int executeNativeUpdate(NativeSQLQuerySpecification arg0, QueryParameters arg1) throws HibernateException {
        notImplemented();
        return 0;
    }

    public int executeUpdate(String arg0, QueryParameters arg1) throws HibernateException {
        notImplemented();
        return 0;
    }

    public void flush() {
        notImplemented();
    }

    public Batcher getBatcher() {
        notImplemented();
        return null;
    }

    public CacheMode getCacheMode() {
        notImplemented();
        return null;
    }

    public Serializable getContextEntityIdentifier(Object arg0) {
        notImplemented();
        return null;
    }

    public int getDontFlushFromFind() {
        notImplemented();
        return 0;
    }

    public Map getEnabledFilters() {
        notImplemented();
        return null;
    }

    public EntityMode getEntityMode() {
        notImplemented();
        return null;
    }

    public EntityPersister getEntityPersister(String arg0, Object arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    public Object getEntityUsingInterceptor(EntityKey arg0) throws HibernateException {
        notImplemented();
        return null;
    }

    public SessionFactoryImplementor getFactory() {
        notImplemented();
        return null;
    }

    public String getFetchProfile() {
        notImplemented();
        return null;
    }

    public Type getFilterParameterType(String arg0) {
        notImplemented();
        return null;
    }

    public Object getFilterParameterValue(String arg0) {
        notImplemented();
        return null;
    }

    public FlushMode getFlushMode() {
        notImplemented();
        return null;
    }

    public Interceptor getInterceptor() {
        notImplemented();
        return null;
    }

    public JDBCContext getJDBCContext() {
        notImplemented();
        return null;
    }

    public EventListeners getListeners() {
        notImplemented();
        return null;
    }

    public Query getNamedQuery(String arg0) {
        notImplemented();
        return null;
    }

    public Query getNamedSQLQuery(String arg0) {
        notImplemented();
        return null;
    }

    public PersistenceContext getPersistenceContext() {
        notImplemented();
        return null;
    }

    public long getTimestamp() {
        notImplemented();
        return 0;
    }

    public String guessEntityName(Object arg0) throws HibernateException {
        notImplemented();
        return null;
    }

    public Object immediateLoad(String arg0, Serializable arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    public void initializeCollection(PersistentCollection arg0, boolean arg1) throws HibernateException {
        notImplemented();
    }

    public Object instantiate(String arg0, Serializable arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    public Object internalLoad(String arg0, Serializable arg1, boolean arg2, boolean arg3) throws HibernateException {
        notImplemented();
        return null;
    }

    public boolean isClosed() {
        notImplemented();
        return false;
    }

    public boolean isConnected() {
        notImplemented();
        return false;
    }

    public boolean isEventSource() {
        notImplemented();
        return false;
    }

    public boolean isOpen() {
        notImplemented();
        return false;
    }

    public boolean isTransactionInProgress() {
        notImplemented();
        return false;
    }

    public Iterator iterate(String arg0, QueryParameters arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    public Iterator iterateFilter(Object arg0, String arg1, QueryParameters arg2) throws HibernateException {
        notImplemented();
        return null;
    }

    public List list(CriteriaImpl arg0) {
        notImplemented();
        return null;
    }

    public List list(String arg0, QueryParameters arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    public List list(NativeSQLQuerySpecification arg0, QueryParameters arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    public List listCustomQuery(CustomQuery arg0, QueryParameters arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    public List listFilter(Object arg0, String arg1, QueryParameters arg2) throws HibernateException {
        notImplemented();
        return null;
    }

    public ScrollableResults scroll(String arg0, QueryParameters arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    public ScrollableResults scroll(CriteriaImpl arg0, ScrollMode arg1) {
        notImplemented();
        return null;
    }

    public ScrollableResults scroll(NativeSQLQuerySpecification arg0, QueryParameters arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    public ScrollableResults scrollCustomQuery(CustomQuery arg0, QueryParameters arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    public void setAutoClear(boolean arg0) {
        notImplemented();
    }

    public void setCacheMode(CacheMode arg0) {
        notImplemented();
    }

    public void setFetchProfile(String arg0) {
        notImplemented();
    }

    public void setFlushMode(FlushMode arg0) {
        notImplemented();
    }

    public Transaction beginTransaction() throws HibernateException {
        notImplemented();
        return null;
    }

    public void cancelQuery() throws HibernateException {
        notImplemented();
    }

    public void clear() {
        notImplemented();
    }

    public Connection close() throws HibernateException {
        notImplemented();
        return null;
    }

    public boolean contains(Object arg0) {
        notImplemented();
        return false;
    }

    public Criteria createCriteria(final Class persistentClass, final String alias) {
        return new CriteriaImpl(persistentClass.getName(), alias, this);
    }

    public Criteria createCriteria(final String entityName, final String alias) {
        return new CriteriaImpl(entityName, alias, this);
    }

    public Criteria createCriteria(final Class persistentClass) {
        return new CriteriaImpl(persistentClass.getName(), this);
    }

    public Criteria createCriteria(final String entityName) {
        return new CriteriaImpl(entityName, this);
    }

    public Query createFilter(Object arg0, String arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    protected HQLQueryPlan getHQLQueryPlan(String query, boolean shallow) throws HibernateException {
        notImplemented();
        return null;
    }

    public Query createQuery(final String queryString) throws HibernateException {
        final Query query = new QueryPlaceholder(queryString);
        query.setComment(queryString);
        return query;
    }

    public SQLQuery createSQLQuery(String arg0) throws HibernateException {
        notImplemented();
        return null;
    }

    public void delete(Object arg0) throws HibernateException {
        notImplemented();
    }

    public void delete(String arg0, Object arg1) throws HibernateException {
        notImplemented();
    }

    public void disableFilter(String arg0) {
        notImplemented();
    }

    public Connection disconnect() throws HibernateException {
        notImplemented();
        return null;
    }

    public Filter enableFilter(String arg0) {
        notImplemented();
        return null;
    }

    public void evict(Object arg0) throws HibernateException {
        notImplemented();
    }

    public Object get(Class arg0, Serializable arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    public Object get(String arg0, Serializable arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    public Object get(Class arg0, Serializable arg1, LockMode arg2) throws HibernateException {
        notImplemented();
        return null;
    }

    public Object get(String arg0, Serializable arg1, LockMode arg2) throws HibernateException {
        notImplemented();
        return null;
    }

    public LockMode getCurrentLockMode(Object arg0) throws HibernateException {
        notImplemented();
        return null;
    }

    public Filter getEnabledFilter(String arg0) {
        notImplemented();
        return null;
    }

    public String getEntityName(Object arg0) throws HibernateException {
        notImplemented();
        return null;
    }

    public Serializable getIdentifier(Object arg0) throws HibernateException {
        notImplemented();
        return null;
    }

    public Session getSession(EntityMode arg0) {
        notImplemented();
        return null;
    }

    public SessionFactory getSessionFactory() {
        notImplemented();
        return null;
    }

    public SessionStatistics getStatistics() {
        notImplemented();
        return null;
    }

    public Transaction getTransaction() {
        notImplemented();
        return null;
    }

    public boolean isDirty() throws HibernateException {
        notImplemented();
        return false;
    }

    public Object load(Class arg0, Serializable arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    public Object load(String arg0, Serializable arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    public void load(Object arg0, Serializable arg1) throws HibernateException {
        notImplemented();
    }

    public Object load(Class arg0, Serializable arg1, LockMode arg2) throws HibernateException {
        notImplemented();
        return null;
    }

    public Object load(String arg0, Serializable arg1, LockMode arg2) throws HibernateException {
        notImplemented();
        return null;
    }

    public void lock(Object arg0, LockMode arg1) throws HibernateException {
        notImplemented();
    }

    public void lock(String arg0, Object arg1, LockMode arg2) throws HibernateException {
        notImplemented();
    }

    public Object merge(Object arg0) throws HibernateException {
        notImplemented();
        return null;
    }

    public Object merge(String arg0, Object arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    public void persist(Object arg0) throws HibernateException {
        notImplemented();
    }

    public void persist(String arg0, Object arg1) throws HibernateException {
        notImplemented();
    }

    public void reconnect() throws HibernateException {
        notImplemented();
    }

    public void reconnect(Connection arg0) throws HibernateException {
        notImplemented();
    }

    public void refresh(Object arg0) throws HibernateException {
        notImplemented();
    }

    public void refresh(Object arg0, LockMode arg1) throws HibernateException {
        notImplemented();
    }

    public void replicate(Object arg0, ReplicationMode arg1) throws HibernateException {
        notImplemented();
    }

    public void replicate(String arg0, Object arg1, ReplicationMode arg2) throws HibernateException {
        notImplemented();
    }

    public Serializable save(Object arg0) throws HibernateException {
        notImplemented();
        return null;
    }

    public Serializable save(String arg0, Object arg1) throws HibernateException {
        notImplemented();
        return null;
    }

    public void saveOrUpdate(Object arg0) throws HibernateException {
        notImplemented();
    }

    public void saveOrUpdate(String arg0, Object arg1) throws HibernateException {
        notImplemented();
    }

    public void setReadOnly(Object arg0, boolean arg1) {
        notImplemented();
    }

    public void update(Object arg0) throws HibernateException {
        notImplemented();
    }

    public void update(String arg0, Object arg1) throws HibernateException {
        notImplemented();
    }

}
