package org.nakedobjects.nos.store.hibernate.security;

import org.nakedobjects.noa.security.SessionManager;
import org.nakedobjects.nof.core.security.AuthenticatorInstaller;
import org.nakedobjects.nof.core.security.StandardAuthenticationManager;


public class DatabaseAuthenticatorInstaller implements AuthenticatorInstaller {

    public SessionManager createAuthenticationManager() {
        StandardAuthenticationManager authenticationManager = new StandardAuthenticationManager();
        authenticationManager.addAuthenticator(new DatabaseAuthenticator());
        return authenticationManager;
    }

    public String getName() {
        return "database";
    }
}
